unit ReadRes;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Dialogs, LCLProc, LazUTF8;

procedure ReadAll(aResList : TStringList);
procedure ReadOnlyTyp(aTyp:PChar;aResList: TStringList);

implementation

var Res_List : array of string;

function ResLangProc(ModuleHandle : TFPResourceHMODULE; ResourceType, ResourceName : PChar; IDLanguage : word; lParam : PtrInt) : LongBool; stdcall;
begin
 // writeln('        Lang: ',IntToHex(IDLanguage,4));
  setlength(Res_List,length(Res_List)+1);
  Res_List[High(Res_List)] := 'Lang: '+ HexStr(IDLanguage,4);

  Result:=true;
  //ResFound(ResourceType,ResourceName,IDLanguage);
end;

function ResNameProc(ModuleHandle : TFPResourceHMODULE; ResourceType, ResourceName : PChar; lParam : PtrInt) : LongBool; stdcall;
var s : string;
begin
  if Is_IntResource(ResourceName) then
   begin
    //writeln('    Name: ',PtrUint(ResourceName))
    s := inttostr(PtrUint(ResourceName));
    setlength(Res_List,length(Res_List)+1);
    Res_List[High(Res_List)] := 'Name: '+s;
   end
  else
   begin
    //writeln('    Name: ',ResourceName);
    setlength(Res_List,length(Res_List)+1);
    Res_List[High(Res_List)] := 'Name: '+ResourceName;
   end;


  EnumResourceLanguages(ModuleHandle,ResourceType,ResourceName,@ResLangProc,lParam);
  Result:=true;
end;

function ResTypeProc(ModuleHandle : TFPResourceHMODULE; ResourceType : PChar; lParam : PtrInt) : LongBool; stdcall;
var s : string;
begin
  if Is_IntResource(ResourceType) then
   begin
    //writeln('Type: ',PtrUint(ResourceType));
    s := inttostr(PtrUint(ResourceType));
    setlength(Res_List,length(Res_List)+1);
    Res_List[High(Res_List)] := 'Type: '+s;
   end
  else
   begin
    //writeln('Type: ',ResourceType);
    setlength(Res_List,length(Res_List)+1);
    Res_List[High(Res_List)] := 'Type: '+ResourceType;
   end;
  EnumResourceNames(ModuleHandle,ResourceType,@ResNameProc,lParam);
  Result:=true;
end;

procedure ReadAll(aResList: TStringList);
var lv       : integer;
    aStrList : TStringList;
begin
 Res_List := [];
 EnumResourceTypes(HINSTANCE,@ResTypeProc,0);
 aStrList := TStringList.Create;
 try
  for lv := 0 to High(Res_List) do
   aStrList.Add(Res_List[lv]);
  aResList.Assign(aStrList);
 finally
  aStrList.Free;
 end;
end;

procedure ReadOnlyTyp(aTyp:PChar;aResList: TStringList);
var lv       : integer;
    aStrList : TStringList;
begin
 Res_List := [];
 EnumResourceNames(HINSTANCE,aTyp,@ResNameProc,0);
 aStrList := TStringList.Create;
 try
  for lv := 0 to High(Res_List) do
   aStrList.Add(Res_List[lv]);
  aResList.Assign(aStrList);
 finally
  aStrList.Free;
 end;

end;


end.

