unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, LCLProc,
  LCLIntf, LCLType, ExtCtrls, Spin, LazUTF8, ReadRes;
type
  TResInfo = record
    Name   : string;
    aType  : string;
    LangId : string;
  end;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_Record: TButton;
    Button_Only14: TButton;
    Button_Only12: TButton;
    Button_Compare: TButton;
    Button_ReadAll: TButton;
    Button_Only10: TButton;
    Edit_Compare: TEdit;
    Image1: TImage;
    Image2: TImage;
    Memo1: TMemo;
    Memo2: TMemo;
    Shape1: TShape;
    SpinEdit_lang: TSpinEdit;
    SpinEdit_Typ: TSpinEdit;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    procedure Button_CompareClick(Sender: TObject);
    procedure Button_Only10Click(Sender: TObject);
    procedure Button_Only12Click(Sender: TObject);
    procedure Button_Only14Click(Sender: TObject);
    procedure Button_ReadAllClick(Sender: TObject);
    procedure Button_RecordClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    MyCur    : TCursorImage;
    InfoList : array of TResInfo;
  public

  end;

var
  Form1: TForm1;

implementation



{$R *.lfm}
{$R myresources.res}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var  RStream: TResourceStream;
begin
 RStream := TResourceStream.Create(HInstance, 'MyText', RT_RCDATA);
  try
    memo2.lines.LoadFromStream(RStream);
  finally
   RStream.free;
  end;
 Image1.Picture.LoadFromResourceName(HInstance,'Bild1');
 Image2.Picture.LoadFromResourceName(HInstance,'Bild2');

 MyCur := TCursorImage.Create;
 MyCur.LoadFromResourceName(HINSTANCE, 'MyCursor');
 Screen.Cursors[15] := MyCur.Handle;
 Memo2.Cursor:= 15;

 Icon.LoadFromResourceName(HInstance,'MyIcon');
end;

procedure TForm1.Button_ReadAllClick(Sender: TObject);
var ResList : TStringList;
    lv : integer;
begin
 Memo1.Clear;
 ResList := TStringlist.Create;
 try
  ReadAll(ResList);
  for lv := 0 to pred(ResList.Count) do
   Memo1.Lines.Add(Reslist[lv]);
 finally
  ResList.Free;
 end;
end;

procedure TForm1.Button_RecordClick(Sender: TObject);
var ResList : TStringList;
    lv,i,j  : integer;
    aPos    : integer;
    aTyp    : string;
    aLang   : boolean;
begin
 Memo1.Clear;
 InfoList := [];
 ResList := TStringlist.Create;
 i := 0;j := 0; aLang := true;
  try
   ReadAll(ResList);
   for lv := 0 to pred(ResList.Count) do
    begin
     setlength(InfoList,i+1);

     if aLang then
     begin
      aPos := Pos('Typ', ResList[lv]);
      if aPos <> 0 then aTyp := ResList[lv];
      InfoList[i].aType := aTyp;
      aLang := false;
      inc(j);
     end;

     aPos := Pos('Name', ResList[lv]);
     if aPos <> 0 then
      begin
       InfoList[i].Name  := ResList[lv];
       inc(j);
      end;

     aPos := Pos('Lang', ResList[lv]);
     if aPos <> 0 then
      begin
       InfoList[i].LangId := ResList[lv];
       aLang := true;
       inc(j)
      end;

     if j=3 then
      begin
       inc(i);
       j := 0;
      end;
    end;
  finally
   ResList.Free;
  end;
 ResList := TStringlist.Create;
 try
  for lv := 0 to length(InfoList)-1 do
   begin
    ResList.Add(InfoList[lv].aType);
    ResList.Add(InfoList[lv].Name);
    ResList.Add(InfoList[lv].LangId);
   end;
  Memo1.Lines.Assign(Reslist);
 finally
  ResList.Free;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 MyCur.Free;
end;

procedure TForm1.Button_Only10Click(Sender: TObject);
var ResList : TStringList;
    lv : integer;
begin
 Memo1.Clear;
 ResList := TStringlist.Create;
 try
  ReadOnlyTyp(PChar(10),ResList);
  for lv := 0 to pred(ResList.Count) do
   Memo1.Lines.Add(Reslist[lv]);
 finally
  ResList.Free;
 end;
end;

procedure TForm1.Button_Only12Click(Sender: TObject);
var ResList : TStringList;
    lv : integer;
begin
 Memo1.Clear;
 ResList := TStringlist.Create;
 try
  ReadOnlyTyp(PChar(12),ResList);
  for lv := 0 to pred(ResList.Count) do
   Memo1.Lines.Add(Reslist[lv]);
 finally
  ResList.Free;
 end;
end;

procedure TForm1.Button_Only14Click(Sender: TObject);
var ResList : TStringList;
    lv : integer;
begin
 Memo1.Clear;
 ResList := TStringlist.Create;
 try
  ReadOnlyTyp(PChar(14),ResList);
  for lv := 0 to pred(ResList.Count) do
   Memo1.Lines.Add(Reslist[lv]);
 finally
  ResList.Free;
 end;
end;

procedure TForm1.Button_CompareClick(Sender: TObject);
var lv    : integer;
    found : boolean;
    aPos  :integer;
begin
 Memo1.Clear;
 Button_RecordClick(nil);
 found := false;

 for lv := 0 to length(InfoList)-1 do
  begin
   if InfoList[lv].aType = 'Type: '+inttostr(SpinEdit_Typ.Value) then
    if InfoList[lv].Name = 'Name: '+Edit_Compare.Text then
     if InfoList[lv].LangId = 'Lang: '+'0000' then //inttostr(SpinEdit_lang.Value) then
      begin
       showmessage('Resource gefunden!');
       found := true;
       aPos := UTF8Pos(Edit_Compare.Text,Memo1.Text);
       if aPos > 0 then
        begin
         Memo1.SelStart  := aPos-1;
         Memo1.SelLength := UTF8Length(Edit_Compare.Text);
         Memo1.SetFocus;
        end;
      end;
  end;
 if not found then showmessage('Resource nicht gefunden!');
end;


end.

